/*
   $Id: Command.h 660 2011-11-09 15:33:00Z manu $
*/


#ifndef COMMAND_H__
#define COMMAND_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "Parameters.h"

class Command {
	public:
		virtual int Main(int argc,char* argv[]) = 0;
		virtual void Usage() const = 0;
		string ComplexityManagementUsage() const;
		string GeneralUsage() const;
	protected:
		virtual ParametersInitializer& _GetInitializer() = 0;
};

inline string Command::ComplexityManagementUsage() const
{
	ostringstream out;
	
	out << "\tcomplexity managment\n";
	out << "\t\t --no-lc-filtering disable low complexity filtering\n";
	out << "\t\t --to-upper  The default is to skip lower case letters, which do not produce any match.\n";
	out << "\t\t              If this switch is specified, the letters are converted to upper case before any computation.\n";
    out << "\t\t --strict  lower case letter in the query sequence will be considered as non reliable nucleotides (=> they always lead to a mismatch)\n";
	
	return out.str();
}

inline string Command::GeneralUsage() const
{
	ostringstream out;
	out << "\terror messages\n";
	out << "\t\t--silent   less messages on stderr\n";
	out << "\t\t--verbose  more messages on stderr\n\n";
	
	return out.str();
}

#endif

